package com.hisschemoller.utils 
{
	/**
	 * @author Wouter Hisschemoller
	 * (c) Jan 6, 2011
	 */
	public class EuclidGeneratorOld
	{
		private var _pattern : Vector.<Boolean> = new Vector.<Boolean>( );
		private var _colSizes : Vector.<int> = new Vector.<int>( );

		public function EuclidGeneratorOld ( total : int, hits : int )
		{
			// Fill the vectors.
			for( var i : uint = 0; i < total; i++ )
			{
				_pattern.push( i < hits );
				_colSizes.push( 1 );
			}
			
			bjorkland( total, hits );
			
			
			log( "d Pattern: " + getPatternString( _pattern ) + " (hits: " + hits + " of total: " + total + ")" );
		}

		public function get pattern () : Vector.<Boolean>
		{
			return _pattern;
		}

		private function bjorkland ( total : int, hits : int ) : int
		{
			log( "i Pattern: " + getPatternString( _pattern ) + ", hits: " + hits + ", total: " + total );
			if( hits == 0 )
			{
				return total;
			}
			else if( hits == 1 )
			{
				return bjorkland( hits, total % hits );
			}
			
			var location : int = 0;
			// var searcher : int = ( total - hits < hits ) ? total - hits : hits;
			var searcher : int = hits;
			log( "i moves to make: " + searcher);
			for( var i : uint = 0; i < searcher; i++ )
			{
				var newColSize : int = _colSizes[ i ] + _colSizes[ _colSizes.length - 1 ];
				var oldLastSize : int = _colSizes[ _colSizes.length - 1 ];
				location += newColSize;
				_colSizes.splice( i, 1 );
				_colSizes.pop( );
				_colSizes.splice( i, 0, newColSize );
				
				for( var j : uint = 0; j < oldLastSize; j++ )
				{
					_pattern.splice( location - oldLastSize, 0, _pattern[ _pattern.length - 1 ] );
					_pattern.pop( );
				}
			}
			log( "i Pattern: " + getPatternString( _pattern ) + ", hits: " + hits + ", total: " + total + ", colSizes: " + _colSizes );
			return bjorkland( hits, total % hits );
		}

		private function getPatternString ( pattern : Vector.<Boolean> ) : String
		{
			var patternString : String = "";
			var n : uint = pattern.length;
			for( var i : uint = 0; i < n; i++)
			{
				patternString += ( pattern[ i ] ) ? "x" : ".";
			}
			
			return patternString;
		}
	}
}
